Toplevel hints:

- It is probably a good idea to not use the root window "."
  for your application. Just remove it with the command:

        wm withdraw .

  in the StartupSrc. This gives you better control over the
  displayed windows. It is also preventing restrictions that
  occur with cut/copy from the root window. It is only
  possible to cut/copy exactly one widget (and its
  descendants) at one time. So if a complete sub widget
  structure from the root widget should be made this can
  lead into many cut/copy operations. A work around is, to
  always use frame as direct child of the root window, and
  to add all children to this frame.


- To display a XF created toplevel window you should use
  the automatically created function:

        ShowWindow.toplevel

  where "toplevel" is the name of the toplevel window, that
  should be displayed. When you are running XF please
  display and remove the toplevel windows with the XF menu
  attached to the label "Current widget path".


- To remove a XF created toplevel window you should use the
  automatically created function: 

        DestroyWindow.toplevel

  where "toplevel" is the name of the toplevel window that
  should be hidden. When you are running XF please display
  and remove the toplevel windows with the XF menu attached
  to the label "Current widget path:".


